export declare function getDatabaseStructure(connectionUrl: string): Promise<DatabaseStructureResponse.Type>;
export declare namespace DatabaseStructureResponse {
    type Type = ErrorResponse | SuccessResponse;
    interface ErrorResponse {
        responseType: 'error';
        responseData: ErrorResponseData;
    }
    interface SuccessResponse {
        responseType: 'success';
        responseData: SuccessResponseData;
    }
    type SuccessResponseData = {
        tables: Array<string>;
    };
    type ErrorResponseData = {
        message: string;
    };
    function createError(message: string): ErrorResponse;
    function createNotFoundError(): ErrorResponse;
    function match<U>(response: Type, onSuccess: (tables: Array<string>) => U, onError: (_: ErrorResponseData) => U): U;
}
