"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const widgets_1 = require("@phosphor/widgets");
class SingletonPanel extends widgets_1.Widget {
    constructor() {
        super(...arguments);
        this.layout = new widgets_1.SingletonLayout();
    }
    onResize(_) {
        if (this._item) {
            this._fitCurrentWidget();
        }
    }
    onActivateRequest() {
        const widget = this.layout.widget;
        if (widget) {
            // Focus the content node if we aren't already focused on it or a
            // descendent.
            if (!widget.node.contains(document.activeElement)) {
                widget.node.focus();
            }
            // Activate the content asynchronously (which may change the focus).
            widget.activate();
        }
    }
    set widget(widget) {
        if (!this.isDisposed) {
            this.layout.widget = widget;
            this._item = new widgets_1.LayoutItem(this.layout.widget);
            this._fitCurrentWidget();
        }
    }
    _fitCurrentWidget() {
        this._item.update(0, 0, this.node.offsetWidth, this.node.offsetHeight);
    }
}
exports.SingletonPanel = SingletonPanel;
