import { IDisposable } from '@phosphor/disposable';
import { Menu, Widget } from '@phosphor/widgets';
import { DataModel } from '@phosphor/datagrid';
import { ISignal } from '@phosphor/signaling';
import * as DataGridExtensions from '../services/dataGridExtensions';
export declare namespace Table {
    interface IOptions {
        contextMenu: Menu;
    }
}
export declare class Table implements IDisposable {
    constructor(model: TableDataModel, options: Table.IOptions);
    static fromKeysRows(keys: Array<string>, data: Array<Array<any>>, options: Table.IOptions): Table;
    readonly widget: Widget;
    readonly selection: DataGridExtensions.BodyCellIndex | null;
    readonly selectionValue: any | null;
    readonly isDisposed: boolean;
    readonly dblclickSignal: ISignal<this, DataGridExtensions.BodyCellIndex>;
    getCellValue(cellIndex: DataGridExtensions.BodyCellIndex): any;
    dispose(): void;
    private _fitColumnWidths;
    private _onClick;
    private _onContextMenu;
    private _onDoubleClick;
    private _updateSelection;
    private _isInBody;
    private _updateRenderers;
    private _textRendererForSelection;
    private readonly _grid;
    private readonly _selectionManager;
    private readonly _clickEventHandler;
    private readonly _contextMenuEventHandler;
    private readonly _dblclickEventHandler;
    private readonly _options;
    private readonly _dblclickSignal;
    private _isDisposed;
}
declare class TableDataModel extends DataModel {
    constructor(keys: Array<string>, data: Array<Array<any>>);
    readonly _data: Array<Array<any>>;
    readonly _keys: Array<string>;
    rowCount(region: DataModel.RowRegion): number;
    columnCount(region: DataModel.ColumnRegion): number;
    data(region: DataModel.CellRegion, row: number, column: number): any;
    _serializeData(data: any): any;
}
export {};
