import { IDisposable } from '@phosphor/disposable';
import { ISignal } from '@phosphor/signaling';
import { VDomModel, VDomRenderer } from '@jupyterlab/apputils';
export interface DatabaseSummaryIModel extends IDisposable {
    navigateToTable: ISignal<this, string>;
    navigateToCustomQuery: ISignal<this, void>;
}
export declare class DatabaseSummaryModel extends VDomModel implements DatabaseSummaryIModel {
    constructor(tables: Array<string>);
    readonly navigateToTable: ISignal<this, string>;
    readonly navigateToCustomQuery: ISignal<this, void>;
    onNavigateToTable(tableName: string): void;
    onNavigateToCustomQuery(): void;
    readonly tables: Array<string>;
    private readonly _navigateToTable;
    private readonly _navigateToCustomQuery;
}
export declare class DatabaseSummaryWidget extends VDomRenderer<DatabaseSummaryModel> {
    constructor();
    static withModel(model: DatabaseSummaryModel): DatabaseSummaryWidget;
    render(): JSX.Element;
}
