"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const components_1 = require("../components");
const Api = require("../api");
class Response {
    constructor() {
        this._widget = new ResponseWidget();
    }
    get widget() {
        return this._widget;
    }
    setResponse(response) {
        this._widget.setResponse(response);
    }
}
exports.Response = Response;
class ResponseWidget extends components_1.SingletonPanel {
    constructor() {
        super(...arguments);
        this._table = null;
    }
    dispose() {
        if (this._table) {
            this._table.dispose();
        }
        super.dispose();
    }
    setResponse(response) {
        this._disposeTable();
        Api.ResponseModel.match(response, (keys, rows) => {
            const table = new components_1.ResultsTable(keys, rows);
            this._table = table;
            this.widget = table.widget;
        }, () => {
            const message = 'Command executed successfully';
            this.widget = new components_1.PreWidget(message);
        }, ({ message }) => {
            this.widget = new components_1.PreWidget(message);
        });
    }
    _disposeTable() {
        if (this._table) {
            this._table.dispose();
        }
        this._table = null;
    }
}
exports.ResponseWidget = ResponseWidget;
