"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const signaling_1 = require("@phosphor/signaling");
const apputils_1 = require("@jupyterlab/apputils");
const components_1 = require("../components");
class QueryToolbar extends apputils_1.Toolbar {
    constructor(connectionUrl) {
        super();
        this._loadingIcon = new components_1.ToolbarItems.LoadingIcon();
        this._backButtonClicked = new signaling_1.Signal(this);
        this._onBackButtonClicked = this._onBackButtonClicked.bind(this);
        this.addItem('back', new components_1.ToolbarItems.BackButton({ onClick: this._onBackButtonClicked }));
        this.addItem('spacer', apputils_1.Toolbar.createSpacerItem());
        this.addItem('url', new components_1.ToolbarItems.ConnectionUrlItem(connectionUrl));
        this.addItem('loading', this._loadingIcon);
    }
    get backButtonClicked() {
        return this._backButtonClicked;
    }
    _onBackButtonClicked() {
        this._backButtonClicked.emit(void 0);
    }
    setLoading(isLoading) {
        this._loadingIcon.setLoading(isLoading);
    }
}
exports.QueryToolbar = QueryToolbar;
