"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const signaling_1 = require("@phosphor/signaling");
class SelectionManager {
    constructor(model) {
        this._selection = null;
        this._selectionChanged = new signaling_1.Signal(this);
        this._maxRow = model.rowCount('body') - 1;
        this._maxColumn = model.columnCount('body') - 1;
    }
    set selection(value) {
        let newSelection = value;
        if (value !== null) {
            const { rowIndex, columnIndex } = value;
            if (rowIndex > this._maxRow ||
                columnIndex > this._maxColumn ||
                rowIndex < 0 ||
                columnIndex < 0) {
                newSelection = null;
            }
        }
        if (newSelection === this._selection) {
            return;
        }
        this._selection = newSelection;
        this._selectionChanged.emit(value);
    }
    get selection() {
        return this._selection;
    }
    get selectionChanged() {
        return this._selectionChanged;
    }
}
exports.SelectionManager = SelectionManager;
